<?php

namespace App\Http\Controllers\Admin;

use App\Association;
use Exception;
use App\Language;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Requests\AssociationRequest;
use Illuminate\Routing\Redirector;
use App\Http\Controllers\Controller;
use Illuminate\Http\RedirectResponse;
use Mcamara\LaravelLocalization\Facades\LaravelLocalization;

class AssociationController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/associations';
    /** View folder */
    private $viewDirectory= 'admin.associations.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('associations.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the associations.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Association::latest();

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('url', 'LIKE', '%'.$request->url.'%');
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $associations= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('associations'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('associations.store');
        $head= __('associations.new');
        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param AssociationRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(AssociationRequest $request) :RedirectResponse
    {
        $association = Association::create($request->all());
        // Insert Description

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param Association $association
     * @return View
     */
    public function edit(Association $association) :View
    {
        $action= route('associations.update', $association->id);
        $head= __('associations.edit');

       

        return view( $this->viewDirectory.'form', compact('association','head', 'action') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param AssociationRequest $request
     * @param Association $association
     * @return RedirectResponse|Redirector
     */
    public function update(AssociationRequest $request, Association $association) :RedirectResponse
    {
        // Update image if request has it
        $association->update($request->all());


        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $association = Association::withTrashed()->find($id);
        if ($association) {
            if ($association->deleted_at) {
                $association->forceDelete();
            } else {
                $association->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several associations by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Association::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Association::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $association = Association::withTrashed()->find($id);

        if ($association){
            $association->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several associations by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $associations = Association::whereIn('id', $request->ids)->onlyTrashed();
        if ($associations){
            $associations->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}